/* Julia Set in GLUT, gkf 3jan2K */ 
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define SGN(x) ((x)<0?-1:1)                   /* signum function */
#define PIXEL 2                               /* fat dots */
#define NAP  1000                             /* microseconds */
#define SLEEP(u) usleep(u)
float red = 1., green = 1., blue = 1. ;        /* default colors */
float nx = 0., ny = 0.5, mx = -1, my = 0;      /* julia data */
float x, y, r; 
/***********************************************************/
void usleep(int nap){int ii; for(ii=0;ii< nap; ii++);}
/***********************************************************/
void dotit(float xx, float yy){ 
     glPointSize(PIXEL);
     glColor3f(red,green,blue); 
     glBegin(GL_POINTS); glVertex2f(xx,yy); glEnd();
}
/***********************************************************/
void wipeit(){
    glClear(GL_COLOR_BUFFER_BIT); glClearColor(0.,0.,0.,0.);  
    nx = RND; ny = RND;        /* also start from a random place */
}
/***********************************************************/
void zapit(){mx = -1; my = 0; wipeit();}
/***********************************************************/
void display(){       
  float x, y, r; 
  x = nx - mx ; y = ny - my;      /* z = nz - m */
  r = sqrt(x*x + y*y);            /* r = |z|   */
  nx = SGN(y)*sqrt((r+x)/2);      /* nz = sqrt(z) */ 
  ny =        sqrt((r-x)/2); 
  if(2*RND < 1){ nx = -nx; ny = -ny;}   /* choose one */
  dotit( nx,  ny);                /* but plot both */ 
  dotit(-nx, -ny);
  SLEEP(NAP);    
}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: fprintf(stderr," Thanks for using GLUT ! \n"); exit(0); break;
     case 'x': mx += .1; break;  /* move modulus x-ward */ 
     case 'X': mx -= .1; break;
     case 'y': my += .1; break;  /* move modulus y-ward */ 
     case 'Y': my -= .1; break; 
     case 'w': wipeit(); break; case 'z': zapit(); break;   
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){ 
  glutInitWindowSize(400, 400);  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Julia Set in GLUT >>");
  glutDisplayFunc(display); glutKeyboardFunc(keyboard); glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION); glLoadIdentity(); 
     glOrtho(-2.0,2.0,-2.0,2.0,-2.0,2.0);
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  glutMainLoop();
  return 0; 
}

/* gkf 14jan2K */
